library(dplyr)
library(openxlsx)

args = commandArgs(trailingOnly=TRUE)

filepath <- args[1]
  "Get Indecies of each Selection"
  AggIndecies <- c(3,4,5,6)
  ConcIndecies <- c(2,9 ,10 , 11)
  NotappIndecies <- 8 #To be kept without changes
  AggRoundIndecies <- 10
  
  MatchedList <<- list(AggIndecies , ConcIndecies , NotappIndecies , AggRoundIndecies)
  AllSubReportContent <- NULL
  AllSummaryContent <- NULL
  "Start Processing of data"
  for (subdir in list.dirs(path = filepath, full.names = TRUE,recursive=FALSE)){
    #ReportContent <- NULL 
    for(file in list.files(subdir)){
      ReportsPath <- paste0(subdir , '\\' , file)
      ReportContent <- read.xlsx(ReportsPath , sheet = 15)
      ReportContent <- ReportContent[,1:10]
      SortedReportContent <- ReportContent[order(ReportContent$Accession),]
      
      ProteinCount <- dim(ReportContent)[1]
      ProteinGroups <- ReportContent[dim(ReportContent)[1] , 1]
      #Remove Reversed Proteins 
      SortedReportContent <- SortedReportContent[!grepl("REVERSED" , SortedReportContent$Name),]
      RemainingProteins <- dim(SortedReportContent)[1]
      ReversedProteins <- dim(ReportContent)[1] - dim(SortedReportContent)[1]
      
      DupliactedIndecies <- which(duplicated(SortedReportContent$Accession))
      if (is.na(DupliactedIndecies[1]))
        DistincitReportContent <- SortedReportContent
      else
        DistincitReportContent <- SortedReportContent[-DupliactedIndecies,]
      #Summary 
      DuplicatesCount <- length(DupliactedIndecies)
      Summarylist <- c(file , ProteinCount , ProteinGroups , ReversedProteins , RemainingProteins , DuplicatesCount)
      AllSummaryContent <- cbind(AllSummaryContent , Summarylist)
      FractionName <- rep(file , dim(DistincitReportContent)[1])
      FractionName <- strsplit(FractionName , " ")[[1]][2]
      DistincitReportContent <- cbind(DistincitReportContent , FractionName)
      AllSubReportContent <- rbind(AllSubReportContent,DistincitReportContent)
    }
    AllSortedReportContent <- AllSubReportContent[order(AllSubReportContent$Accession),]
    AvgCOlnames <- colnames(AllSortedReportContent)[MatchedList[[1]]]
    ConcColnames <- colnames(AllSortedReportContent)[MatchedList[[2]]]
    NotappColnames <- colnames(AllSortedReportContent)[MatchedList[[3]]]
    AvgRoundedColnames <- colnames(AllSortedReportContent)[MatchedList[[4]]]
    
    AvgeragedReportContent <- aggregate(AllSortedReportContent[,AvgCOlnames], list(MainAccesion =AllSortedReportContent[,7]), FUN = mean)
    AvgeragedRoundedReportContent <- aggregate(AllSortedReportContent[,AvgRoundedColnames], list(MainAccesion =AllSortedReportContent[,7]) , FUN = mean)
    AvgeragedRoundedReportContent[,-1] <-ceiling(AvgeragedRoundedReportContent[,-1])  
    ConcReportContent <- setNames(aggregate(AllSortedReportContent[,ConcColnames],
                                            by = list(MainAccesion=AllSortedReportContent[,7]),
                                            paste, collapse="$"),c(colnames(AllSortedReportContent)[7],ConcColnames))
    
    ConcReportContent[ConcReportContent == "$"] <- " "
    ConcReportContent[ConcReportContent == "NA"] <- " "
    ConcReportContent[ConcReportContent == "$NA"] <- " "
    ConcReportContent[ConcReportContent == "NA$"] <- " "
    
    NotappReportContent <- aggregate(AllSortedReportContent[,NotappColnames],list(MainAccesion =AllSortedReportContent[,7]), FUN = function(a) a[1])
    colnames(NotappReportContent)[2] <- "Name"
    colnames(AvgeragedRoundedReportContent)[2] <- "Peptides(95%) Rounded"
    PreReportContent <- merge(AvgeragedReportContent , AvgeragedRoundedReportContent , by = 1)
    PreReportContent <- merge(PreReportContent , ConcReportContent , by = 1)
    FinalReportContent <- merge(PreReportContent , NotappReportContent , by = 1)
    FinalReportContent<-FinalReportContent %>%
      mutate_all(as.character)
    
    colnames(AllSummaryContent) <- AllSummaryContent[1,]
    AllSummaryContent <- AllSummaryContent[-1,] 
    rownames(AllSummaryContent) <- c("Proteins count" ,"Protein Groups" , "Reversed proteins" , "Remaining proteins" , "Number of Duplicates")
    AllSummaryContent <- as.data.frame(AllSummaryContent)
    OutputSplitted <- strsplit(subdir , '/')
    OutputName <- OutputSplitted[[1]][length(OutputSplitted[[1]])]
    OutputPath <- paste0(subdir , '\\' , paste0(OutputName , '.csv'))
    SummaryName <- paste0(subdir , '\\' ,  'Summary.csv')
    write.csv(FinalReportContent, OutputPath)
    write.csv(AllSummaryContent, SummaryName)
    
    ReportContent <- NULL 
    AllSubReportContent <- NULL
    AllSummaryContent <- NULL
  }

